<?php
namespace App\Models;
use CodeIgniter\Model;
class CitaModel extends Model
{
    protected $table      = 'cita';
    protected $primaryKey = 'id_cita';

    protected $useAutoIncrement = true;

    protected $returnType     = 'array';
    protected $useSoftDeletes = false;

    protected $allowedFields = ['fecha','hora','id_paciente', 'id_personal','id_servicio','estado_cita','motivo'];

    protected $useTimestamps = true;
    protected $createdField  = 'fecha_alta';
    protected $updatedField  = 'fecha_modifica';
    protected $deletedField  = '';

    protected $validationRules    = [];
    protected $validationMessages = [];
    protected $skipValidation     = false;

    public function datos(){
        $this->select('*');
        $this->join('paciente', 'paciente.id_paciente = cita.id_paciente ');
        $this->join('personal', 'personal.id_personal = cita.id_personal ');
        $this->join('servicios', 'servicios.id_servicio = cita.id_servicio ');
        $datos= $this->orderBy('id_cita', 'DESC')->findAll() ;
        return $datos;
    }
    public function datos_ID($id){
        $this->select('*');
        $this->join('paciente', 'paciente.id_paciente = cita.id_paciente ');
        $this->join('personal', 'personal.id_personal = cita.id_personal ');
        $this->join('servicios', 'servicios.id_servicio = cita.id_servicio ');
        $datos= $this->where('cita.id_cita', $id)->first() ;
        return $datos;
    }

}
?>