<?php
namespace App\Models;
use CodeIgniter\Model;
class ResultadosPruebaModel extends Model
{
    protected $table      = 'resultados_de_prueba';
    protected $primaryKey = 'id_resultado';

    protected $useAutoIncrement = true;

    protected $returnType     = 'array';
    protected $useSoftDeletes = false;

    protected $allowedFields = ['id_paciente','id_laboratorio','fecha','id_tipolab','resultado','estado_resultado'];

    protected $useTimestamps = true;
    protected $createdField  = 'fecha_alta';
    protected $updatedField  = 'fecha_modifica';
    protected $deletedField  = '';

    protected $validationRules    = [];
    protected $validationMessages = [];
    protected $skipValidation     = false;

    public function datos(){
        $this->select('*');
        $this->join('tipo_laboratorio','tipo_laboratorio.id_tipolab=resultados_de_prueba.id_tipolab');
        $this->join('laboratorio','laboratorio.id_laboratorio=resultados_de_prueba.id_laboratorio');
        $this->join('paciente','paciente.id_paciente =resultados_de_prueba.id_paciente');

        $datos= $this->orderBy('id_resultado')->findAll() ;
        return $datos;
    }

    public function historial_lab($id)
    {
        $this->select('*');
        $this->join('laboratorio','laboratorio.id_laboratorio=resultados_de_prueba.id_laboratorio');
        $this->join('paciente','paciente.id_paciente=resultados_de_prueba.id_paciente');
        $this->join('tipo_laboratorio','tipo_laboratorio.id_tipolab=resultados_de_prueba.id_tipolab');
        $this->where('resultados_de_prueba.id_paciente', $id);
        $this->where('resultados_de_prueba.estado_resultado', 0);
        $datos= $this->orderBy('resultados_de_prueba.fecha','DESC')->findAll() ;

        return $datos;
    }

}
?>