<?php

namespace App\Controllers;

use App\Controllers\BaseController;
use App\Models\PacienteModel;
use App\Models\DetallePermisosModel;
use App\Models\PermisosModel;
use App\Models\ResultadosPruebaModel;

use FPDF;
use TCPDF;


class paciente extends BaseController
{
    protected $paciente, $session, $roles, $reglas, $reglasCambia, $permisos, $detalle_rol, $resultado_laboratorio, $reglasCambia_accesos;

    public function __construct()
    {
        $this->paciente = new PacienteModel();
        $this->detalle_rol = new DetallePermisosModel();
        $this->permisos = new PermisosModel();
        $this->resultado_laboratorio = new ResultadosPruebaModel();
        $this->session = session();

        helper(['form']);


        $this->reglas =
            [
                'ci' =>
                [
                    'rules' => 'required|is_unique[paciente.ci]',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                        'is_unique' => 'El campo {field} debe ser unico.'
                    ]
                ],
                'fecha_nacimiento' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'edad' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'genero' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'nombre' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'extencion' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'direccion' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'telefono' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'email' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ]
            ];

        $this->reglasCambia =
            [
                'nombre' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'fecha_nacimiento' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'edad' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'genero' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'ci' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'extencion' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'direccion' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'telefono' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'email' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ]
            ];

        $this->reglasCambia_accesos =
            [
                'email' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.'
                    ]
                ],
                'clave' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.'
                    ]
                ]
            ];
    }

    /* INICIO */
    public function index()
    {
        $paciente = $this->paciente->orderBy('id_paciente', 'DESC')->findAll();
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);


        $data = ['datos' => $paciente, 'validacion_sw' => 0, 'permisos' => $permisos];
        $view =
            view('header', $data) .
            view('paciente/paciente', $data) .
            view('footer');
        return $view;
    }
    public function insertar()
    {
        if ($this->request->getMethod() == "post" && $this->validate($this->reglas)) {
            $hash = $this->request->getPost('clave');
            $this->paciente->save([
                'nombre' => strtoupper($this->request->getPost('nombre')),
                'fecha_nacimiento' => $this->request->getPost('fecha_nacimiento'),
                'direccion' => $this->request->getPost('direccion'),
                'edad' => $this->request->getPost('edad'),
                'estado_civil' => $this->request->getPost('estado_civil'),
                'ocupacion' => $this->request->getPost('ocupacion'),
                'genero' => $this->request->getPost('genero'),
                'ci' => $this->request->getPost('ci'),
                'extencion' => $this->request->getPost('extencion'),
                'telefono' => $this->request->getPost('telefono'),
                'email' => $this->request->getPost('email'),
                'clave' => password_hash("$hash", PASSWORD_DEFAULT)
            ]);

            return redirect()->to(base_url() . 'paciente');
        } else {
            $paciente = $this->paciente->findAll();
            $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

            $data = ['datos' => $paciente, 'validation' => $this->validator, 'validacion_sw' => 0, 'permisos' => $permisos];
            $view =
                view('header', $data) .
                view('paciente/paciente', $data) .
                view('footer');
            return $view;
        }
    }

    public function editar($id, $valid = null)
    {
        $paciente = $this->paciente->where('id_paciente', $id)->first();
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

        if ($valid != null) {
            $data = ['datos' => $paciente, 'validation' => $valid, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('paciente/editar', $data);
            echo view('footer');
        } else {
            $data = ['datos' => $paciente, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('paciente/editar', $data);
            echo view('footer');
        }
    }

    public function editar_accesos($id, $valid = null)
    {
        $paciente = $this->paciente->where('id_paciente', $id)->first();
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

        if ($valid != null) {
            $data = ['datos' => $paciente, 'validation' => $valid, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('paciente/editar_accesos', $data);
            echo view('footer');
        } else {
            $data = ['datos' => $paciente, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('paciente/editar_accesos', $data);
            echo view('footer');
        }
    }


    public function actualizar()
    {
        $id = $this->request->getPost('id_paciente');
        $nombre_paciente = $this->request->getPost('nombre');
        $datos = $this->paciente->where('id_paciente !=', $id)->where('nombre', $nombre_paciente)->first();
        if (!$datos) {

            if ($this->request->getMethod() == "post" && $this->validate($this->reglasCambia)) {

                $this->paciente->update($this->request->getPost('id_paciente'), [
                    'nombre' => strtoupper($this->request->getPost('nombre')),
                    'fecha_nacimiento' => $this->request->getPost('fecha_nacimiento'),
                    'edad' => $this->request->getPost('edad'),
                    'genero' => $this->request->getPost('genero'),
                    'ci' => $this->request->getPost('ci'),
                    'estado_civil' => $this->request->getPost('estado_civil'),
                    'ocupacion' => $this->request->getPost('ocupacion'),
                    'extencion' => $this->request->getPost('extencion'),
                    'direccion' => $this->request->getPost('direccion'),
                    'telefono' => $this->request->getPost('telefono'),
                    'email' => $this->request->getPost('email'),

                ]);

                return redirect()->to(base_url() . 'paciente');
            } else {

                return $this->editar($this->request->getPost('id_paciente'), $this->validator);
            }
        } else {

            $paciente = $this->paciente->findAll();
            $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

            $data = ['datos' => $paciente, 'validacion_sw' => 1, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('paciente/paciente', $data);
            echo view('footer');
        }
    }


    public function actualizar_accesos()
    {
        $id = $this->request->getPost('id_paciente');
        $email = $this->request->getPost('email');
        $hash = $this->request->getPost('clave');
        $datos = $this->paciente->where('id_paciente !=', $id)->where('email', $email)->first();
        if (!$datos) {

            if ($this->request->getMethod() == "post" && $this->validate($this->reglasCambia_accesos)) {

                $this->paciente->update($this->request->getPost('id_paciente'), [
                    'email' => $this->request->getPost('email'),
                    'clave' => password_hash("$hash", PASSWORD_DEFAULT)
                ]);

                return redirect()->to(base_url() . 'paciente');
            } else {

                return $this->editar_accesos($this->request->getPost('id_paciente'), $this->validator);
            }
        } else {

            $paciente = $this->paciente->findAll();
            $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

            $data = ['datos' => $paciente, 'validacion_sw' => 1, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('paciente/paciente', $data);
            echo view('footer');
        }
    }


    public function buscarpaciente($id)
    {
        $datos = $this->paciente->datosAjax($id);

        $res['existe'] = false;
        $res['datos'] = '';
        $res['error'] = '';
        if ($datos) {
            $res['datos'] = $datos;
            $res['existe'] = true;
        } else {
            $res['error'] = 'No existe dato';
            $res['existe'] = false;
        }
        echo json_encode($res);
    }

    public function historial($id)
    {

        $historial = $this->paciente->historial($id);
        $resultado_laboratorio = $this->resultado_laboratorio->historial_lab($id);
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

        $data = ['historiales' => $historial, 'permisos' => $permisos, 'historial_labs' => $resultado_laboratorio];

        echo view('header', $data);
        echo view('paciente/historial', $data);
        echo view('footer');
    }



    public function historial_pdf($id_paciente)
    {
        // Crear una nueva instancia de TCPDF
        $pdf = new TCPDF('P', 'mm', 'A4');
        $pdf->AddPage();
        $pdf->SetMargins(20, 20, 20);
        $pdf->SetTitle("Historial");

       
        // Iniciar contenido HTML
        $html = '<u><h1 style=" text-align: center;">HISTORIA CLINICA</h1></u>';
        $html .= '<br>';

        $db = \Config\Database::connect();
        $query = $db->query("SELECT * FROM prescripcion pre 
                             INNER JOIN paciente pa ON pa.id_paciente = pre.id_paciente
                             INNER JOIN cita ci ON ci.id_paciente = pre.id_paciente
                             INNER JOIN medicamento me on me.id_medicamento = pre.id_medicamento
                             WHERE pa.id_paciente = '$id_paciente'");

        $resultados = $query->getResultArray();

        if (count($resultados) > 0) {
            // Obtén los datos del primer registro del paciente
            $nombre = $resultados[0]['nombre'];
            $genero = $resultados[0]['genero'];
            $fecha_nacimiento = $resultados[0]['fecha_nacimiento'];
            $edad = $resultados[0]['edad'];
            $motivo = $resultados[0]['motivo'];

            // Agregar información de afiliación en HTML
            $html .= '<h4>1. AFILIACION</h4>';
            $html .= '<br>';

            $html .= '<table style="border-collapse: collapse; width: 100%; ">';
            $html .= '<tr>';
            $html .= '<th>' . "Nombre y apellidos " . '</th>';
            $html .= '<th>' . "Edad " . '</th>';
            $html .= '<th>' . "Genero " . '</th>';
            $html .= '</tr>';
            $html .= '</table>';


            $html .= '<table style="border-collapse: collapse;width: 100%; ">';
            $html .= '<tr>';
            $html .= '<td>' . $nombre . '</td>';
            $html .= '<td>' . $edad . '</td>';
            $html .= '<td>' . $genero . '</td>';
            $html .= '</tr>';
            $html .= '</table>';
            $html .= '<br>';
            $html .= '<hr>';

            // Agregar consultas, medicamentos, etc.
            foreach ($resultados as $dato) {
                $fecha = $dato['fecha'];
                $hora = $dato['hora'];

                $html .= '<p><b style="color:red">MOTIVO CONSULTA : </b> ' . $motivo . '</p>';

               
                $html .= '<p><b>Fecha consulta:</b> ' . $fecha . ' ' . $hora . '</p>';
                $html .= '<p><b>Medicamento:</b> ' . $dato['nombre_medicamento'] . '</p>';
                $html .= '<p><b>Dosis:</b> ' . $dato['dosis'] . '</p>';
                $html .= '<p><b>Indicaciones:</b> ' . $dato['indicaciones'] . '</p>';
                $html .= '<br>';
            }
        } else {
            // Si no hay resultados
            $html .= '<p><b>EL PACIENTE NO TIENE HISTORIAL CLINICO</b></p>';
        }

        // Insertar el contenido HTML en el PDF
        $pdf->writeHTML($html, true, false, true, false, '');

        // Mostrar el PDF
        $this->response->setHeader('Content-Type', 'application/pdf');
        $pdf->Output("historial_clinico.pdf", "I");
    }




    public function historial_pdf1($id_paciente)
    {


        $mes = array("Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre");

        $pdf = new \FPDF('P', 'mm', 'letter');
        $pdf->AddPage();
        $pdf->SetMargins(20, 20, 20);
        $pdf->SetTitle("Comprobante");
        /*   $historial = $this->paciente->historial($id);
        $resultado_laboratorio = $this->resultado_laboratorio->historial_lab($id);
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo); */

        $db = \Config\Database::connect();
        $query = $db->query("SELECT * FROM prescripcion pre inner join paciente pa on pa.id_paciente = pre.id_paciente
                               inner join cita ci on ci.id_paciente = pre.id_paciente
                               where ci.id_paciente = '$id_paciente' ");
        $resultados = $query->getResultArray();

        foreach ($resultados as $dato) {

            $nombre =  $dato['nombre'];
            $fecha_nacimiento = $dato['fecha_nacimiento'];

            $edad = $dato['edad'];
            $genero = $dato['genero'];
            $fecha = $dato['fecha'];
            $hora = $dato['hora'];
        }

        // Selecciona la fuente: Arial, negrita, tamaño 16
        $pdf->SetFont('Arial', 'B', 16);

        // Mueve el cursor al centro
        $pdf->Cell(0, 10, 'HISTORIAL CLINICO', 0, 1, 'C');

        $pdf->Ln(10); // Espacio

        // Fuente Arial normal, tamaño 12
        $pdf->SetFont('Arial', '', 12);

        // Datos del paciente
        $pdf->Cell(50, 10, 'PACIENTE : ');
        $pdf->Cell(0, 10, $nombre, 0, 1);

        $pdf->Cell(50, 10, 'FECHA NACIMIENTO : ');
        $pdf->Cell(0, 10, $fecha_nacimiento, 0, 1);

        $pdf->Cell(50, 10, 'FECHA CONSULTA :');
        $pdf->Cell(0, 10, $fecha . ' ' . $hora, 0, 1);

        $pdf->Ln(10); // Espacio

        $query1 = $db->query("SELECT * FROM prescripcion p inner join medicamento m on m.id_medicamento = p.id_medicamento where  id_paciente='$id_paciente' ");
        $resultados1 = $query1->getResultArray();

        $contador = 0;
        foreach ($resultados1 as $dato1) {

            $dato1['nombre_medicamento'];
            $dato1['dosis'];
            $dato1['indicaciones'];
        }

        // Diagnóstico
        $pdf->SetFont('Arial', 'B', 12);
        $pdf->Cell(0, 10, 'HISTORIAL ', 0, 1);
        $pdf->SetFont('Arial', '', 12);
        $pdf->MultiCell(0, 10, 'diagnoos');

        $pdf->Ln(10); // Espacio

        // Tratamiento
        $pdf->SetFont('Arial', 'B', 12);
        $pdf->Cell(0, 10, 'Tratamiento:', 0, 1);
        $pdf->SetFont('Arial', '', 12);
        $pdf->MultiCell(0, 10, 'trattt');



        $pdf->SetFont('Courier', '', 7);
        /*  $pdf->Cell(176, 4, 'Documento no valido para credito fiscal, solo para fines de control interno.', 0, 0, 'C'); */
        $this->response->setHeader('Content-Type', 'application/pdf');
        $pdf->Output("contrato.pdf", "I");





        /*  $data = ['historiales' => $historial, 'permisos' => $permisos, 'historial_labs' => $resultado_laboratorio];

        echo view('header', $data);
        echo view('paciente/historial', $data);
        echo view('footer');  */
    }
}
