<?php

namespace App\Controllers;

use App\Controllers\BaseController;
use App\Models\TipolabModel;
use App\Models\DetallePermisosModel;
use App\Models\PermisosModel;

class Tipolab extends BaseController
{
    protected $tipolab, $session, $roles, $reglas, $reglasCambia, $permisos, $detalle_rol;

    public function __construct()
    {
        $this->tipolab = new tipolabModel();
        $this->detalle_rol = new DetallePermisosModel();
        $this->permisos = new PermisosModel();

        $this->session = session();

        helper(['form']);


        $this->reglas =
            [
                'nombre_tipolab' =>
                [
                    'rules' => 'required|is_unique[tipo_laboratorio.nombre_tipolab]',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                        'is_unique' => 'El campo {field} debe ser unico.'
                    ]
                ]
            ];

        $this->reglasCambia =
            [
                'nombre_tipolab' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ]  
                
            ];
    }

    /* INICIO */
    public function index()
    {
        $tipolab = $this->tipolab->findAll();
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

        $data = ['datos' => $tipolab, 'validacion_sw' => 0, 'permisos' => $permisos];
        $view =
            view('header', $data) .
            view('tipolab/tipolab', $data) .
            view('footer');
        return $view;
    }
    public function insertar()
    {
        if ($this->request->getMethod() == "post" && $this->validate($this->reglas)) {

            $this->tipolab->save([
                'nombre_tipolab' => strtoupper($this->request->getPost('nombre_tipolab')),
                'estado_tipolab' => 1,
           
            ]);

            return redirect()->to(base_url() . 'tipolab');
        } else {
            $tipolab = $this->tipolab->findAll();
            $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

            $data = ['datos' => $tipolab, 'validation' => $this->validator, 'validacion_sw' => 0, 'permisos' => $permisos];
            $view =
                view('header', $data) .
                view('tipolab/tipolab', $data) .
                view('footer');
            return $view;
        }
    }

    public function editar($id, $valid = null)
    {
        $tipolab = $this->tipolab->where('id_tipolab', $id)->first();
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

        if ($valid != null) {
            $data = ['datos' => $tipolab, 'validation' => $valid, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('tipolab/editar', $data);
            echo view('footer');
        } else {
            $data = ['datos' => $tipolab, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('tipolab/editar', $data);
            echo view('footer');
        }
    }

    public function actualizar()
    {
        $id = $this->request->getPost('id_tipolab');
        $nombre_tipolab = $this->request->getPost('nombre_tipolab');
        $datos = $this->tipolab->where('id_tipolab !=', $id)->where('nombre_tipolab', $nombre_tipolab)->first();
        if (!$datos) {

            if ($this->request->getMethod() == "post" && $this->validate($this->reglasCambia)) {

                $this->tipolab->update($this->request->getPost('id_tipolab'), [
                    'nombre_tipolab' => strtoupper($this->request->getPost('nombre_tipolab')),
                    'estado_tipolab' => $this->request->getPost('estado_tipolab'),
                ]);
                return redirect()->to(base_url() . 'tipolab');
            } else {
                return $this->editar($this->request->getPost('id_tipolab'), $this->validator);
            }
        } else {

            $tipolab = $this->tipolab->findAll();
            $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);

            $data = ['datos' => $tipolab, 'validacion_sw' => 1, 'permisos' => $permisos];
            echo view('header', $data);
            echo view('tipolab/tipolab', $data);
            echo view('footer');
        }
    }
}
