<?php
namespace App\Models;
use CodeIgniter\Model;
class CargoModel extends Model
{
    protected $table      = 'cargo';
    protected $primaryKey = 'id_cargo';

    protected $useAutoIncrement = true;

    protected $returnType     = 'array';
    protected $useSoftDeletes = false;

    protected $allowedFields = ['nombre_cargo','estado_cargo'];

    protected $useTimestamps = true;
    protected $createdField  = 'fecha_alta';
    protected $updatedField  = 'fecha_modifica';
    protected $deletedField  = '';

    protected $validationRules    = [];
    protected $validationMessages = [];
    protected $skipValidation     = false;

    public function detalle_rol($id){
        $this->select('*');
        $this->join('detalle_roles_permiso', 'detalle_roles_permiso.id_cargo=cargo.id_cargo ');
        $this->join('permisos', 'permisos.id_permiso=detalle_roles_permiso.id_permiso ');
        $datos = $this->where(['detalle_roles_permiso.id_cargo' => $id])->doFindAll();
        return $datos;
    }

}
?>