<?php
namespace App\Models;
use CodeIgniter\Model;
class PersonalModel extends Model
{
    protected $table      = 'personal';
    protected $primaryKey = 'id_personal';

    protected $useAutoIncrement = true;

    protected $returnType     = 'array';
    protected $useSoftDeletes = false;

    protected $allowedFields = ['nombre_personal','ci','id_especialidad','ci','extension','telefono','email','id_cargo','usuario','clave','estado_personal'];

    protected $useTimestamps = true;
    protected $createdField  = 'fecha_alta';
    protected $updatedField  = 'fecha_modifica';
    protected $deletedField  = '';

    protected $validationRules    = [];
    protected $validationMessages = [];
    protected $skipValidation     = false;

    public function datosSession($usuario)
    {
        $this->select('*');
        $this->join('cargo', 'cargo.id_cargo = personal.id_cargo ');
        $this->where(['estado_personal' => '1']);
        $datos = $this->where(['personal.usuario' => $usuario])->first();
      
        return $datos;
    }

    public function datos(){
        $this->select('*');
        $this->join('cargo', 'cargo.id_cargo = personal.id_cargo ');
        $this->join('especialidad', 'especialidad.id_especialidad = personal.id_especialidad');
        $datos= $this->orderBy('id_personal')->findAll() ;
        return $datos;
    }

    public function medicos(){
        $this->select('*');
        $this->join('cargo', 'cargo.id_cargo = personal.id_cargo ');
        $datos= $this->orderBy('id_personal')->where('cargo.nombre_cargo','MEDICO')->findAll() ;
        return $datos;
    }


}
?>