<script>
    function establecerFechaMinimaMaxima() {
        const hoy = new Date();

        // Si hoy es domingo (0), avanzar un día
        if (hoy.getDay() === 0) {
            hoy.setDate(hoy.getDate() + 1);
        }

        // Calcular el día siguiente
        const mañana = new Date(hoy);
        mañana.setDate(hoy.getDate() + 30);

        // Formatear la fecha como YYYY-MM-DD
        const formatearFecha = (fecha) => {
            const anio = fecha.getFullYear();
            const mes = String(fecha.getMonth() + 1).padStart(2, '0'); // Mes 0-11
            const dia = String(fecha.getDate()).padStart(2, '0');
            return `${anio}-${mes}-${dia}`;
        };

        const fechaMinima = formatearFecha(hoy);
        const fechaMaxima = formatearFecha(mañana);

        // Establecer los valores mínimo y máximo del input
        const inputFecha = document.getElementById('fecha');
        inputFecha.setAttribute('min', fechaMinima);
        inputFecha.setAttribute('max', fechaMaxima);
    }

    // Llamar a la función al cargar la página
    window.onload = establecerFechaMinimaMaxima;
</script>

<div class="main-content">

    <div class="page-content">
        <div class="container-fluid">

            <div class="row g-3">
                <div class="col-12">
                    <div class="card">
                        <div class="card-body">
                            <div class="col-md-12">
                                <div class="page-title-box d-sm-flex align-items-center justify-content-between card flex-sm-row border-0">
                                    CLINICA NIEVES > LISTA GENERAL DE ATENCION MEDICA 
                                </div>
                            </div>

                            <div class=" row g-3">
                              
                                <div class="col-md-12">
                                    <table id="datatable-buttons" class="table table-bordered dt-responsive nowrap w-100 ">
                                        <thead>
                                            <tr>
                                                <th class="text-center bg-primary text-white">ID</th>
                                                <th class="text-center bg-primary text-white">FOLIO</th>
                                                <th class="text-center bg-primary text-white">ESTADO</th>
                                                <th class="text-center bg-primary text-white">FECHA HORA</th>
                                                <th class="text-center bg-primary text-white">PACIENTE</th>
                                                <th class="text-center bg-primary text-white">SERVICIO</th>
                                                <th class="text-center bg-primary text-white">MEDICO</th>
                                                <th class="text-center bg-primary text-white"></th>
                                                <th class="text-center bg-primary text-white">TICKET</th>
                                                <th class="text-center bg-primary text-white"></th>
                                            </tr>
                                        </thead>

                                        <tbody>
                                            <?php
                                            $contador = 0;
                                            foreach ($datos as $dato) {
                                                $contador++; ?>
                                                <tr>
                                                    <td><?= $contador; ?></td>
                                                    <td><?= $dato['folio']; ?></td>
                                                    <?php if ($dato['estado_cita'] == 1) { ?>
                                                        <td><span class="badge text-bg-danger">Pendiente</span></td>
                                                    <?php } else { ?>
                                                        <td><span class="badge text-bg-success">Atendido</span></td>
                                                    <?php } ?>
                                                    <td><?= $dato['fecha'] . ' ' . $dato['hora']; ?></td>
                                                    <td><?= $dato['nombre']; ?></td>
                                                    <td><?= $dato['nombre_personal']; ?></td>
                                                    <td><?= $dato['nombre_servicio']; ?></td>


                                                    <?php if ($dato['estado_cita'] == 1) { ?>
                                                        <td><a href="<?php echo base_url() . 'cita/editar/' . $dato['id_cita']; ?>" class="btn bg-danger btn-sm text-white ">
                                                                <i class="fas fa-edit "></i>Editar</a></td>
                                                    <?php } else { ?>
                                                        <td><a href="<?php echo base_url() . 'cita/editar/' . $dato['id_cita']; ?>" class="btn bg-danger btn-sm text-white disabled">
                                                                <i class="fas fa-edit "></i>Editar</a></td>
                                                    <?php } ?>
                                                    <td>
                                                        <a href="<?php echo base_url() . 'cita/ticket/' . $dato['id_cita']; ?>" class="btn bg-warning btn-sm text-white " target="_blank"><i class="far fa-file-pdf"></i>Descargar</a>
                                                    </td>
                                                    <td><a href="<?php echo base_url() . 'cita/atencion_cita/' . $dato['id_cita']; ?>" class="btn bg-success btn-sm text-white ">
                                                            <i class="fas fa-plus "></i> Prescripcion</a></td>

                                                </tr>
                                            <?php
                                            }
                                            ?>


                                        </tbody>
                                    </table>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script>
        $(document).ready(function() {
            $("#id_paciente").change(function(tagCodigo, e) {
                $("#id_paciente option:selected").each(function() {
                    id_paciente = $(this).val();
                    $.ajax({
                        url: '<?= base_url(); ?>paciente/buscarpaciente/' + id_paciente,
                        type: 'POST',
                        dataType: 'json',
                        data: 'id_paciente=' + id_paciente,
                        success: function(resultado) {
                            if (resultado == 0) {
                                $(tagCodigo).val('');
                            } else {
                                $(tagCodigo).removeClass('has-error');
                                $("#error_carguio").html(resultado.error);
                                if (resultado.existe) {
                                    $("#id_paciente").val(resultado.datos
                                        .id_paciente);
                                    $("#edad").val(resultado.datos
                                        .edad);
                                    $("#ci").val(resultado.datos
                                        .ci);
                                } else {
                                    $("#id_paciente").val('');
                                    $("#edad").val('');
                                    $("#ci").val('');
                                }
                            }
                        }
                    });
                });
            });
        });
    </script>